'''
Created on Oct 23, 2017

@author: szabo eduard, popovici iulian, solomon andrei

Se citeste un sir de numere de la tastatura
Sa se afiseze numerele prime din sir

'''
from curses.ascii import isalpha

def citire():
    """
    Descr: Functia citeste un sir de numere, pana la intalnirea caracterului x
    # orice alt input invalid este ignorat
    
    Args: None
    
    Returns: lista citita
    """
    n=" "
    l=[]
    print("dati sirul de numere, caracterul x va pune capat citirii")
    while(True):
        n=input("nr crt= ")
        if(n=="X" or n=="x"):
            return l
        elif(n.isdigit()):
            l.append(int(n))
        else:
            print("input invalid")
          
  
def prim(x):
    """
    verifica daca un numar este prim
    args: nr x
    returns: true or false
    """
    if(x<2):
        return False
    if(x==2):
        return True
    if(x % 2==0):
        return False
    for d in range(3,int(x**0.5)+1,2):
        if x%d==0:
            return False
    return True

def listPrime(vector):
    '''
    Functia elimina numerele care nu sunt prime din lista
    IN: Lista
    OUT: Lista modificata
    '''
    i = 0
    n = len(vector)
    while (i < n):
        if (prim(vector[i])):
            i += 1
        else:
            vector.pop(i)
            n -= 1
    return vector

def isPrimeSieve(x):
    """
    functia verifica daca un numar este prim folosind ciurul lui Eratostene
    obs: pentru cazul nostru nu e eficient
    in: numarul pentru a fi verificat
    out: true or false
    """
    if(x < 2):
        return False
    v = [0]*(x + 1)
    v[0] = 1
    v[1] = 1
    j = 2
    for i in range(2, len(v)):
        if(v[i] == 0):
            for j in range(i * i, len(v), i):
                v[j] = 1
                
    return v[x] == 0

def testIsPrimeSieve():
    assert isPrimeSieve(-1)==False
    assert isPrimeSieve(0)==False
    assert isPrimeSieve(1)==False
    assert isPrimeSieve(4)==False
    assert isPrimeSieve(9)==False
    assert isPrimeSieve(2)==True
    assert isPrimeSieve(7)==True
    assert isPrimeSieve(15)==False
    print("functia isPrimeSieve a trecut prin toate testele")

def testListPrime():
    assert listPrime([]) == []
    assert listPrime([4, 9, 16, 25]) == []
    assert listPrime([3, 5, 7]) == [3, 5, 7]
    assert listPrime([1, 2, 3, 4, 5, 6]) == [2, 3, 5]
    assert listPrime([-3, -18, 2, 7, 15, 3]) == [2, 7, 3]
    assert listPrime([0]) == []
    print("Functia listPrime a trecut testele")

def testPrim():
    assert prim(-1)==False
    assert prim(0)==False
    assert prim(1)==False
    assert prim(4)==False
    assert prim(9)==False
    assert prim(2)==True
    assert prim(7)==True
    assert prim(15)==False
    print("functia prim a trecut prin toate testele")
    
    

def run():
    testIsPrimeSieve()
    testPrim()
    testListPrime()
    sir = citire()
    print("Sirul este: ",sir)
    sirP = listPrime(sir)
    print("Sirul modificat este: ", sirP)
    
    
run()